"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.extractConfigFromState = exports.minimalConfig = exports.defaultConfig = void 0;

/**
 * Config after sanitizing in extractConfigFromState.
 */

/**
 * Config as it can be provided by the user.
 * Comments indicate transformations made to conform to InternalConfig format.
 */

/**
 * Config containing the settings used if they are missing in the user-specified config.
 */
const defaultConfig = {
  powerAssert: true,
  autoImport: true,
  staticTruthCheck: false,
  assertFunctionName: ''
};
/**
 * Config that disables all but the core set of features.
 */

exports.defaultConfig = defaultConfig;
const minimalConfig = {
  powerAssert: false,
  autoImport: false
}; // tslint:disable no-parameter-reassignment

exports.minimalConfig = minimalConfig;

const extractConfigFromState = ({
  opts: {
    powerAssert,
    autoImport,
    staticTruthCheck,
    assertFunctionName
  }
}) => {
  // powerAssert
  if (powerAssert === undefined) {
    powerAssert = defaultConfig.powerAssert;
  } // autoImport


  if (autoImport === undefined) {
    autoImport = defaultConfig.autoImport;
  }

  if (autoImport === false) {
    autoImport = '';
  }

  if (autoImport === true) {
    autoImport = 'power-assert';
  } // staticTruthCheck


  if (staticTruthCheck === undefined) {
    staticTruthCheck = defaultConfig.staticTruthCheck;
  } // assertFunctionName


  if (assertFunctionName === undefined) {
    assertFunctionName = defaultConfig.assertFunctionName;
  }

  return {
    powerAssert,
    autoImport,
    staticTruthCheck,
    assertFunctionName
  };
};

exports.extractConfigFromState = extractConfigFromState;