"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _assertifyStatement = _interopRequireDefault(require("./assertify-statement"));

var _config = require("./config");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const assertionBlockLabels = ['expect', 'then'];

const plugin = babel => {
  return {
    visitor: {
      LabeledStatement(path, state) {
        const config = (0, _config.extractConfigFromState)(state);
        const assertify = (0, _assertifyStatement.default)(babel, state, config);

        if (assertionBlockLabels.includes(path.node.label.name)) {
          const bodyPath = path.get('body');

          switch (bodyPath.type) {
            case 'BlockStatement':
              const statementPaths = bodyPath.get('body');
              statementPaths.forEach(assertify);
              break;

            default:
              assertify(bodyPath);
          }
        }
      }

    }
  };
};

var _default = plugin;
exports.default = _default;